/*:
## **Aufgabe Geisterfahrer**
*/

/**
Beschreibung eines Autos

- author: Klaus Reinold
- version: 1.0
*/
class Auto: Figur
{

    /**
	Konstruktor für Objekte der Klasse Auto
	- parameters:
		- farbe: Farbe des zu erstellenden Autos
    */
    init(farbe: String)
    {
        super.init()
        FigurteilFestlegenRechteck(x: -30, y: -50, breite: 60, höhe: 100, farbe: farbe)
        FigurteilFestlegenRechteck(x: -28, y: 10, breite: 56, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: 46, breite: 8, höhe: 4, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 12, y: 46, breite: 8, höhe: 4, farbe: "weiss")
        GrößeSetzen(größe: 80)
    }
}


/**
Die entgegenkommenden Autos

- author: Klaus Reinold
- version: 1.0
*/
class Geisterauto: Auto
{
    var fahrspur: Int
    var yPos: Int
    

    /**
    Konstruktor für Objekte der Klasse Geisterauto
	- parameters:
		- fahrspurNeu: die Fahrspur für das Auto
    	- y: die Ausgangsposition in Fahrtrichtung
    */
    init(fahrspurNeu: Int, farbe: String, y: Int)
    {
        fahrspur = fahrspurNeu
        yPos = y
        super.init(farbe: farbe)
        
        PositionSetzen(x: fahrspur * 80 + 40, y: yPos)
    }
    
    /**
    Bewegungsmethode des Autos
    */
    func Fahren()
    {
        yPos = yPos + 5
        if yPos > 600
        {
            yPos = -50
        }
        PositionSetzen(x: fahrspur * 80 + 40, y: yPos)
    }
}

/**
Das tastaturgesteuerte Auto des Spielers

- author: Klaus Reinold
- version: 1.0
*/
class Spielerauto: Auto
{
    /** x-Position des Spielerautos*/
    var xPos: Int
    /** y-Position des Spielerautos*/
    var yPos: Int

    /**
    Konstruktor für Objekte der Klasse Spielerauto
    */
    init()
    {
        xPos = 40;
        yPos = 460;
        super.init(farbe: "weiß")
        Drehen(grad: 180)
        PositionSetzen(x: xPos, y: yPos)
    }

    /**
    Bewegung des Spielerautos nach links/rechts
	- parameters:
		- richtung: die Bewegungsrichtung (links / rechts)
    */
    func Bewegen(richtung: String)
    {
        print(richtung)
        if richtung == "links"
        {
            if xPos > 0
            {
                xPos = xPos - 40
            }
        }
        else if richtung == "rechts"
        {
            if xPos < 240
            {
                xPos = xPos + 40
            }
        }
        PositionSetzen(x: xPos, y: yPos)
    }
}

/**
Spielsteuerung

 * @author Klaus Reinold
- author: Klaus Reinold
- version: 1.0
*/
class Spiel: Ereignisbehandlung
{
    /** Das Geisterauto 1*/
    var auto1: Geisterauto
    /** Das Geisterauto 2*/
    var auto2: Geisterauto
    /** Das Geisterauto 3*/
    var auto3: Geisterauto

    /** Das Spielerauto 1*/
    var spielerauto: Spielerauto

    /**
     * Konstruktor des Spiels
     */
    override init()
    {
        let strasse = Rechteck()
        strasse.GrößeSetzen(breite: 240, höhe: 600)
        strasse.FarbeSetzen(farbe: "grau")
        strasse.PositionSetzen(x: 0,y: 0)

        for i in 1 ..< 3
        {
            for j in 0 ..< 14
            {
                let fahrbahnmarkierung = Rechteck()
                fahrbahnmarkierung.FarbeSetzen(farbe: "weiß")
                fahrbahnmarkierung.GrößeSetzen(breite: 4,höhe: 20)
                fahrbahnmarkierung.PositionSetzen(x: 80*i-2,y: 40*j)
            }
		}
        auto1 = Geisterauto(fahrspurNeu: 0, farbe: "rot", y: -200)
        auto2 = Geisterauto(fahrspurNeu: 1, farbe: "grün",y: 50)
        auto3 = Geisterauto(fahrspurNeu: 2, farbe: "magenta", y: 300)
        spielerauto = Spielerauto()
        super.init()
        TaktdauerSetzen(dauer: 800)
        Starten();
    }

    /**
    Taktsteuerung der Geisterautos
    */
    override func TaktImpulsAusführen()
    {
        auto1.Fahren()
        auto2.yPos = auto2.yPos + 5
        auto3.Fahren()
    }

    /**
    Tastatursteuerung des Spielerautos
	- parameters:
		- taste: die gedrückte Taste
    */
    override func SonderTasteGedrückt(taste: Int)
    {
        super.SonderTasteGedrückt(taste: taste)
        if taste == 123
        {
            spielerauto.xPos = spielerauto.xPos - 40
        }
        if taste == 124
        {
            spielerauto.Bewegen(richtung: "rechts")
        }
    }
}



Spiel()
