/*:
## **Aufgabe Smart-Home Prototyp 1**
*/

/**
Ein graues Rechteck für die Wände des Hauses

- author: Johannes Neumeyer
- version: 1.0
*/
class Hausmauer: Rechteck
{

    /**
    Konstruktor für Objekte der Klasse Hausmauer
    */
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "grau")
    }
    
    /**
    Konstruktor für Objekte der Klasse Hausmauer  mit angegebener Position
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    convenience init(x: Int, y:Int)
    {
        self.init()
        PositionSetzen(x: x, y: y)
    }
}

/**
Darstellung eines Fensters

- author: Johannes Neumeyer
- version: 1.0
*/
class FensterSymbol
{
    private var links: Rechteck
    private var rechts: Rechteck
    private var oben: Rechteck
    private var unten: Rechteck
    private var kreuzSenkrecht: Rechteck
    private var kreuzWaagrecht: Rechteck

    /**
    Erzeugt das Fenstersymbol
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        let höhe = 100
        let breite = höhe

        links = Rechteck()
        links.GrößeSetzen(breite: 2, höhe: höhe)
        links.PositionSetzen(x: x, y: y)
        links.FarbeSetzen(farbe: "braun")

        oben = Rechteck()
        oben.GrößeSetzen(breite: breite, höhe: 2)
        oben.PositionSetzen(x: x, y: y)
        oben.FarbeSetzen(farbe: "braun")

        unten = Rechteck()
        unten.GrößeSetzen(breite: breite, höhe: 2)
        unten.PositionSetzen(x: x, y: y + höhe - 2)
        unten.FarbeSetzen(farbe: "braun")

        rechts = Rechteck()
        rechts.GrößeSetzen(breite: 2, höhe: höhe)
        rechts.PositionSetzen(x: x + breite - 2, y: y)
        rechts.FarbeSetzen(farbe: "braun")

        kreuzSenkrecht = Rechteck()
        kreuzSenkrecht.GrößeSetzen(breite: 2, höhe: höhe)
        kreuzSenkrecht.PositionSetzen(x: x + breite / 2, y: y)
        kreuzSenkrecht.FarbeSetzen(farbe: "braun")

        kreuzWaagrecht = Rechteck()
        kreuzWaagrecht.GrößeSetzen(breite: breite, höhe: 2)
        kreuzWaagrecht.PositionSetzen(x: x, y: y + höhe / 2)
        kreuzWaagrecht.FarbeSetzen(farbe: "braun")
    }
}

/**
Der Hintergrund des Hauses

- author: Johannes Neumeyer
- version: 1.0
*/
class HintergrundSymbol
{
    /**
    Legt die Wände, das Dach und die Beschriftung an.
    */
    init()
    {
        let dachlinks = Dreieck()
        dachlinks.FarbeSetzen(farbe: "rot")
        dachlinks.GrößeSetzen(breite: 550, höhe: 100)
        dachlinks.PositionSetzen(x: 400, y: 0)
        let unten = Hausmauer(x: 150, y: 500)
        unten.GrößeSetzen(breite: 500, höhe: 5)
        let mitteWaagrecht = Hausmauer(x: 150, y: 300)
        mitteWaagrecht.GrößeSetzen(breite: 500, höhe: 5)
        let oben = Hausmauer(x: 150, y: 100)
        oben.GrößeSetzen(breite: 500, höhe: 5)
        let links = Hausmauer(x: 150, y: 100)
        links.GrößeSetzen(breite: 5, höhe: 400)
        let rechts = Hausmauer(x: 645, y: 100)
        rechts.GrößeSetzen(breite: 5, höhe: 400)
        let mitteSenkrecht = Hausmauer(x: 395, y: 100)
        mitteSenkrecht.GrößeSetzen(breite: 5, höhe: 400)
        FensterSymbol(x: 250, y: 125)
        FensterSymbol(x: 250, y: 325)
        FensterSymbol(x: 500, y: 125)
        FensterSymbol(x: 500, y: 325)

        let wohnzimmer1 = Text()
        wohnzimmer1.TextSetzen(text: "Wohnzimmer1")
        wohnzimmer1.FarbeSetzen(farbe: "grau")
        wohnzimmer1.TextGrößeSetzen(größe: 15)
        wohnzimmer1.PositionSetzen(x: 160, y: 120)

        let wohnzimmer2 = Text()
        wohnzimmer2.TextSetzen(text: "Wohnzimmer2")
        wohnzimmer2.FarbeSetzen(farbe: "grau")
        wohnzimmer2.TextGrößeSetzen(größe: 15)
        wohnzimmer2.PositionSetzen(x: 405, y: 120)

        let küche = Text()
        küche.TextSetzen(text: "Küche")
        küche.FarbeSetzen(farbe: "grau")
        küche.TextGrößeSetzen(größe: 15)
        küche.PositionSetzen(x: 160, y: 320)

        let esszimmer = Text()
        esszimmer.TextSetzen(text: "Esszimmer")
        esszimmer.FarbeSetzen(farbe: "grau")
        esszimmer.TextGrößeSetzen(größe: 15)
        esszimmer.PositionSetzen(x: 405, y: 320)
    }
}

/**
Darstellung eines Heizkörpers

- author: Johannes Neumeyer
- version: 1.0
*/
class HeizkörperSymbol
{
    private var innenkreise: [Kreis]
    private var innenrechtecke: [Rechteck]

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        innenkreise = []
        innenrechtecke = []
        
        for index in 0 ..< 8
        {
            HeizkörperSegmentAnPos(x: x + index * 10, y: y)
        }
    }
    
    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- an: der Heizkörper ist eingeschaltet
    */
    func ÄnderungMelden(an: Bool)
    {
        if an
        {
            for k in innenkreise
            {
                k.FarbeSetzen(farbe: "rot")
            }
            
            for r in innenrechtecke
            {
                r.FarbeSetzen(farbe: "rot")
            }

        }
        else
        {
            for k in innenkreise
            {
                k.FarbeSetzen(farbe: "weiß")
            }
            
            for r in innenrechtecke
            {
                r.FarbeSetzen(farbe: "weiß")
            }
        }
    }

	/**
	Fügt dem Heizkörper ein neues Segment hinzu
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    private func HeizkörperSegmentAnPos(x: Int, y: Int)
    {
        // Segment außen
        let oben = Kreis()
        oben.RadiusSetzen(radius: 10)
        oben.PositionSetzen(x: x + 10, y: y + 10)
        oben.FarbeSetzen(farbe: "schwarz")

        let mitte = Rechteck()
        mitte.GrößeSetzen(breite: 21, höhe: 40)
        mitte.PositionSetzen(x: x, y: y + 10)
        mitte.FarbeSetzen(farbe: "schwarz")

        let unten  = Kreis()
        unten.RadiusSetzen(radius: 10)
        unten.PositionSetzen(x: x + 10, y: y + 50)
        unten.FarbeSetzen(farbe: "schwarz")

        // Segment innen
        let obenInnen = Kreis()
        obenInnen.RadiusSetzen(radius: 8)
        obenInnen.PositionSetzen(x: x + 10, y: y + 10)
        obenInnen.FarbeSetzen(farbe: "weiß")
        innenkreise.append(obenInnen)

        let mitteInnen = Rechteck()
        mitteInnen.GrößeSetzen(breite: 17, höhe: 42)
        mitteInnen.PositionSetzen(x: x + 2, y: y + 9)
        mitteInnen.FarbeSetzen(farbe: "weiß")
        innenrechtecke.append(mitteInnen)

        let untenInnen  = Kreis()
        untenInnen.RadiusSetzen(radius: 8)
        untenInnen.PositionSetzen(x: x + 10, y: y + 50)
        untenInnen.FarbeSetzen(farbe: "weiß")
        innenkreise.append(untenInnen)
    }
}

/**
Darstellung einer Lampe

- author: Johannes Neumeyer
- version: 1.0
*/
class LampenSymbol
{
    private let kabel: Rechteck
    private let schirm: Dreieck
    private let birne: Kreis

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        kabel = Rechteck()
        kabel.PositionSetzen(x: x, y: y)
        kabel.GrößeSetzen(breite: 1, höhe: 30)
        kabel.FarbeSetzen(farbe: "schwarz")
        birne = Kreis()
        birne.RadiusSetzen(radius: 10)
        birne.PositionSetzen(x: x, y: y + 55)
        birne.FarbeSetzen(farbe: "weiß")
        schirm = Dreieck()
        schirm.GrößeSetzen(breite: 50, höhe: 25)
        schirm.PositionSetzen(x: x, y: y + 30)
        schirm.FarbeSetzen(farbe: "grau")
    }

    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- an: die Lampe ist eingeschaltet
    */
    func ÄnderungMelden(an: Bool)
    {
        if an
        {
            birne.FarbeSetzen(farbe: "gelb")
        }
        else
        {
            birne.FarbeSetzen(farbe: "weiß")
        }
    }
}

/**
Darstellung eines Rolladens

- author: Johannes Neumeyer
- version: 1.0
*/
class RollladenSymbol
{
    private let lamelle0: Rechteck
    private let lamelle1: Rechteck
    private let lamelle2: Rechteck
    private let lamelle3: Rechteck
    private let lamelle4: Rechteck
    private let lamelle5: Rechteck
    private let lamelle6: Rechteck
    private let lamelle7: Rechteck
    private let lamelle8: Rechteck

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        lamelle0 = Rechteck()
        lamelle0.FarbeSetzen(farbe: "schwarz")
        lamelle0.GrößeSetzen(breite: 100, höhe: 10)
        lamelle0.PositionSetzen(x: x, y: y)

        lamelle1 = Rechteck()
        lamelle1.FarbeSetzen(farbe: "schwarz")
        lamelle1.GrößeSetzen(breite: 100, höhe: 10)
        lamelle1.PositionSetzen(x: x, y: y + 11)

        lamelle2 = Rechteck()
        lamelle2.FarbeSetzen(farbe: "schwarz")
        lamelle2.GrößeSetzen(breite: 100, höhe: 10)
        lamelle2.PositionSetzen(x: x, y: y + 22)

        lamelle3 = Rechteck()
        lamelle3.FarbeSetzen(farbe: "schwarz")
        lamelle3.GrößeSetzen(breite: 100, höhe: 10)
        lamelle3.PositionSetzen(x: x, y: y + 33)

        lamelle4 = Rechteck()
        lamelle4.FarbeSetzen(farbe: "schwarz")
        lamelle4.GrößeSetzen(breite: 100, höhe: 10)
        lamelle4.PositionSetzen(x: x, y: y + 44)

        lamelle5 = Rechteck()
        lamelle5.FarbeSetzen(farbe: "schwarz")
        lamelle5.GrößeSetzen(breite: 100, höhe: 10)
        lamelle5.PositionSetzen(x: x, y: y + 55)

        lamelle6 = Rechteck()
        lamelle6.FarbeSetzen(farbe: "schwarz")
        lamelle6.GrößeSetzen(breite: 100, höhe: 10)
        lamelle6.PositionSetzen(x: x, y: y + 66)

        lamelle7 = Rechteck()
        lamelle7.FarbeSetzen(farbe: "schwarz")
        lamelle7.GrößeSetzen(breite: 100, höhe: 10)
        lamelle7.PositionSetzen(x: x, y: y + 77)

        lamelle8 = Rechteck()
        lamelle8.FarbeSetzen(farbe: "schwarz")
        lamelle8.GrößeSetzen(breite: 100, höhe: 10)
        lamelle8.PositionSetzen(x: x, y: y + 88)
    }

    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- oben: der Rolladen ist oben
    */
    func ÄnderungMelden(oben: Bool)
    {
        if oben
        {
            lamelle1.SichtbarkeitSetzen(sichtbar: false)
            lamelle2.SichtbarkeitSetzen(sichtbar: false)
            lamelle3.SichtbarkeitSetzen(sichtbar: false)
            lamelle4.SichtbarkeitSetzen(sichtbar: false)
            lamelle5.SichtbarkeitSetzen(sichtbar: false)
            lamelle6.SichtbarkeitSetzen(sichtbar: false)
            lamelle7.SichtbarkeitSetzen(sichtbar: false)
            lamelle8.SichtbarkeitSetzen(sichtbar: false)
        }
        else
        {
            lamelle1.SichtbarkeitSetzen(sichtbar: true)
            lamelle2.SichtbarkeitSetzen(sichtbar: true)
            lamelle3.SichtbarkeitSetzen(sichtbar: true)
            lamelle4.SichtbarkeitSetzen(sichtbar: true)
            lamelle5.SichtbarkeitSetzen(sichtbar: true)
            lamelle6.SichtbarkeitSetzen(sichtbar: true)
            lamelle7.SichtbarkeitSetzen(sichtbar: true)
            lamelle8.SichtbarkeitSetzen(sichtbar: true)
        }
    }
}
//#-editable-code
/**
Beschreibt einen Bewegungsmelder

- author: Albert Wiedemann
- version 1.0
 */
class Bewegungsmelder
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Messung */
    var an: Bool
    /** Lampe, der Änderungen gemeldet werden */
    var beobachter: Lampe!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Bewegungsmelder \(namensZusatz)"
        beobachter = nil
        an = false
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Lampe)
    {
        self.beobachter = beobachter
    }
    
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- an: der neue Sensorwert
    */
    func WertSetzen (an: Bool)
    {
        self.an = an
        beobachter.WertänderungMeldenBewegungsmelder(wert: an)
    }
    
    /**
    Meldet den Zustand des Sensors
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "Bewegung" : "Ruhe"
    }
}

/**
Beschreibt einen Lichtsensor

- author: Albert Wiedemann
- version 1.0
*/
class Sonnensensor
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Messung */
    var aktuellerWert: Int
    /** Lampe, der Änderungen gemeldet werden */
    var beobachter: Lampe!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Bewegungsmelder \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Lampe)
    {
        self.beobachter = beobachter
    }
    
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe <= 100)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMeldenSonnenSensor(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand des Sensors
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) %"
    }
}

/**
Beschreibt eine Lampe

- author: Albert Wiedemann
- version 1.0
*/
class Lampe
{
    /** Name der Hauskomponente */
    let name: String
    /** Zustand der Lampe */
    var an: Bool
    /** Automatikbetrieb */
    var automatik: Bool
    /** Wert des Bewegungsmelders */
    var bewegung: Bool
    /** Wert des Sonnensensors */
    var helligkeit: Int
    /** Darstellungssymbol */
    let symbol: LampenSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- b: Bewegungsmelder
		- s: Sonnensensor
    */
    init(namensZusatz: String, sy: LampenSymbol, b: Bewegungsmelder, s: Sonnensensor)
    {
        name = "Lampe \(namensZusatz)"
        bewegung = false
        helligkeit = 0
        an = false
        automatik = true
        symbol = sy
        symbol.ÄnderungMelden(an: an)
        s.BeobachterRegistrieren(beobachter: self)
        b.BeobachterRegistrieren(beobachter: self)
    }

    /**
	Wird von Sonnensensor bei einem neuen Helligkeitswert aufgerufen
	- parameters:
		- wert: der neue Helligkeitswert
    */
    func WertänderungMeldenSonnenSensor(wert: Int)
    {
        helligkeit = wert
        if automatik
        {
            an = bewegung && (helligkeit < 30)
            symbol.ÄnderungMelden(an: an)
        }
    }

    /**
    Wird von Bewegungsmelder bei einem neuen Bewegungszustand aufgerufen
	- parameters:
		- wert: der neue Bewegungswert
    */
    func WertänderungMeldenBewegungsmelder(wert: Bool)
    {
        bewegung = wert
        if automatik
        {
            an = bewegung && (helligkeit < 30)
            symbol.ÄnderungMelden(an: an)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "ein" : "aus"
    }
    
    /**
    Schaltet die Komponente dauerhaft ein
    */
    func Einschalten()
    {
        an = true
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente dauerhaft aus
    */
    func Ausschalten()
    {
        an = false
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        an = bewegung && (helligkeit < 30)
        automatik = true
        symbol.ÄnderungMelden(an: an)
    }
}

/**
Beschreibt ein Thermometer

- author: Albert Wiedemann
- version 1.0
*/
class Thermometer
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Messung */
    var aktuellerWert: Int
    /** Heizkörper, dem Änderungen gemeldet werden */
    var beobachter: Heizkörper!

    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Thermometer \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
     
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Heizkörper)
    {
        self.beobachter = beobachter
    }
   
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= -50) && (eingabe <= 100)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMelden(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) ˚C"
    }
}

/**
Beschreibt einen Heizkörper

- author: Albert Wiedemann
- version 1.0
*/
class Heizkörper
{
    /** Name der Hauskomponente */
    let name: String
    /** Zustand der Lampe */
    var an: Bool
    /** Automatikbetrieb */
    var automatik: Bool
    /** Wert des Thermometers */
    var temperatur: Int
    /** Darstellungssymbol */
    let symbol: HeizkörperSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- t: Thermometer
    */
    init(namensZusatz: String, sy: HeizkörperSymbol, t: Thermometer)
    {
        name = "Heizkörper \(namensZusatz)"
        temperatur = 0
        an = true
        automatik = true
        symbol = sy
        symbol.ÄnderungMelden(an: an)
        t.BeobachterRegistrieren(beobachter: self)
    }

    /**
	Wird von Sonnensensor bei einem neuen Helligkeitswert aufgerufen
	- parameters:
		- wert: der neue Temperaturwert
    */
    func WertänderungMelden(wert: Int)
    {
        temperatur = wert
        if automatik
        {
            an = temperatur < 22
            symbol.ÄnderungMelden(an: an)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "ein" : "aus"
    }
    
    /**
    Schaltet die Komponente dauerhaft ein
    */
    func Einschalten()
    {
        an = true
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente dauerhaft aus
    */
    func Ausschalten()
    {
        an = false
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        an = temperatur < 22
        automatik = true
        symbol.ÄnderungMelden(an: an)
    }
}

/**
Beschreibt eine Waage

- author: Albert Wiedemann
- version 1.0
*/
class Waage
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Messung */
    var aktuellerWert: Int
    /** Kühlschrank, dem Änderungen gemeldet werden */
    var beobachter: Kühlschrank!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Waage\(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Kühlschrank)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe < 10000)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMelden(wert: eingabe)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) g"
    }
}

/**
Beschreibt einen Kühlschrank

- author: Albert Wiedemann
- version 1.0
*/
class Kühlschrank
{
    /** Name der Hauskomponente */
    let name: String
    /** Zustand des Eierfachs */
    var leer: Bool
    /** Wert der Waage */
    var gewicht: Int
    /** Darstellungssymbol */
    //let symbol: KühlschrankSymbol

    /**
     * Legt den Namen und das Darstellungssymbol fest
     * @param namensZusatz individualler Namensteil der Komponente
     * @param sy Darstellungssymbol
     * @param w Waage
     */
    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- w: Waage
    */
    init(namensZusatz: String, /*sy: KühlschrankSymbol, */w: Waage)
    {
        name = "Kühlschrank \(namensZusatz)"
        gewicht = 0
        leer = true
        w.BeobachterRegistrieren(beobachter: self)
    }

    /**
	Wird von der Waage bei einem neuen Gewicht aufgerufen
	- parameters:
		- wert: das neue Gewicht
    */
    func WertänderungMelden(wert: Int)
    {
        gewicht = wert
        leer = gewicht < 100
        //Symbol
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return leer ? "Eierfach leer" : "Eierfach voll"
    }
    
    /**
     * Tut nichts
     */
    func Einschalten()
    {
    }
    
    /**
     * Tut nichts
     */
    func Ausschalten()
    {
    }
    
    /**
     * Tut nichts
     */
    func AutomatikAktivieren()
    {
    }
}

/**
Beschreibt eine Uhr

- author: Albert Wiedemann
- version 1.0
*/
class Uhr
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Zeit, Stunden */
    var stunden: Int
    /** aktueller Wert der Zeit, minuten */
    var minuten: Int
    /** aktueller Wert der Zeit, Sekunden */
    var sekunden: Int
    /** Rollladen, dem Änderungen gemeldet werden */
    var beobachter: Rollladen!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Uhr\(namensZusatz)"
        beobachter = nil
        stunden = 0
        minuten = 0
        sekunden = 0
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Rollladen)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- stunden: der neue Sensorwert
    */
    func WertSetzen (stunden: Int)
    {
        if (stunden >= 0) && (stunden < 24)
        {
            self.stunden = stunden
            beobachter.WertänderungMeldenUhr(wert: stunden*10000 + minuten*100 + sekunden)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(stunden):" + (minuten < 10 ? "0\(minuten)" : "\(minuten)") + ":" + (sekunden < 10 ? "0\(sekunden)" : "\(sekunden)") + "Uhr"
    }
}

/**
Beschreibt einen Windsensor

- author: Albert Wiedemann
- version 1.0
*/
class Windsensor
{
    /** Name des Sensors */
    let name: String
    /** aktueller Wert der Messung */
    var aktuellerWert: Int
    /** Rolladen, dem Änderungen gemeldet werden */
    var beobachter: Rollladen!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Windsensor \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Rollladen)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe <= 12)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMeldenWindSensor(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) Bft"
    }
}

/**
Beschreibt einen Rolladen

- author: Albert Wiedemann
- version 1.0
*/
class Rollladen
{
    /** Name der Hauskomponente */
    let name: String
    /** Zustand des Rollladens */
    var oben: Bool
    /** Automatikbetrieb */
    var automatik: Bool
    /** Wert des Windsensors */
    var windwert: Int
    /** Wert der Uhr */
    var uhrzeit: Int
    /** Darstellungssymbol */
    let symbol: RollladenSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- w: Windsensor
		- u: Uhr
    */
    init(namensZusatz: String, sy: RollladenSymbol, w: Windsensor, u: Uhr)
    {
        name = "Rollladen \(namensZusatz)"
        oben = false
        automatik = true
        windwert = 0
        uhrzeit = 0
        symbol = sy
        symbol.ÄnderungMelden(oben: oben)
        w.BeobachterRegistrieren(beobachter: self)
        u.BeobachterRegistrieren(beobachter: self)
    }

    /**
	Wird vom Windsensor bei einer neuen Windstärke aufgerufen
	- parameters:
		- wert: die neue Windstärke
    */
    func WertänderungMeldenWindSensor(wert: Int)
    {
        windwert = wert
        if automatik
        {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
            symbol.ÄnderungMelden(oben: oben)
        }
    }

    /**
	Wird vom Windsensor bei einer neuen Windstärke aufgerufen
	- parameters:
		- wert: die neue Windstärke
    */
    func WertänderungMeldenUhr(wert: Int)
    {
        uhrzeit = wert
        if automatik
        {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
            symbol.ÄnderungMelden(oben: oben)
        }
    }
        
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return oben ? "offen" : "geschlossen"
    }

    /**
    Zieht den Rollladen dauerhaft hoch
    */
    func Hochziehen()
    {
        oben = true
        automatik = false
        symbol.ÄnderungMelden(oben: oben)
    }
    
    /**
    lässt den Rollladen dauerhaft runter
    */
    func Runterlassen()
    {
        oben = false
        automatik = false
        symbol.ÄnderungMelden(oben: oben)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
        automatik = true
        symbol.ÄnderungMelden(oben: oben)
    }
}


/**
Verwaltung des Hauses

- author: Albert Wiedemann
- version: 1.0
*/
class Haus
{
    private let hintergrund: HintergrundSymbol
    private let thermometerEsszimmer: Thermometer
    private let heizkörperSymbolEsszimmer: HeizkörperSymbol
    private let heizkörperEsszimmer: Heizkörper

    /**
    legt die Sensoren und Komponenten des Hauses an
    */
    init()
    {
        hintergrund = HintergrundSymbol()
        thermometerEsszimmer = Thermometer(namensZusatz: "Esszimmer")
        heizkörperSymbolEsszimmer = HeizkörperSymbol(x: 420, y: 440)
        heizkörperEsszimmer = Heizkörper(namensZusatz: "Esszimmer", sy: heizkörperSymbolEsszimmer, t: thermometerEsszimmer)
    }
    
    /**
	Setzt das Thermometer im Esszimmer auf einen neuen Wert
	- parameters:
		- eingabe: neuer Temperaturwert
    */
    func ThermometerEsszimmerWertSetzen (eingabe: Int)
    {
        thermometerEsszimmer.WertSetzen(eingabe: eingabe)
    }
    
    /**
    Schaltet den Heizkörper im Esszimmer dauerhaft ein
    */
    func HeizkörperEsszimmerEinschalten()
    {
        heizkörperEsszimmer.Einschalten()
    }
    
    /**
    Schaltet den Heizkörper im Esszimmer dauerhaft aus
    */
    func HeizkörperEsszimmerAusschalten()
    {
        heizkörperEsszimmer.Ausschalten()
    }
    
    /**
    Setzt den Heizkörper im Esszimmer auf Automatikbetrieb
    */
    func HeizkörperEsszimmerAutomatikSetzen()
    {
        heizkörperEsszimmer.AutomatikAktivieren()
    }
    
    /**
    Zeigt die zustände aller Geräte an
    */
    func ZuständeAnzeigen()
    {
    	print(thermometerEsszimmer.name + ": " + thermometerEsszimmer.ZustandGeben())
        print(heizkörperEsszimmer.name + ": " + heizkörperEsszimmer.ZustandGeben())
    }
}

//#-end-editable-code

//#-editable-code

let h = Haus()
//h.ThermometerEsszimmerWertSetzen(eingabe: 25)

h.ZuständeAnzeigen()

//#-end-editable-code
